# coding: utf-8

"""
    Pure Storage FlashBlade REST 1.9 Python SDK

    Pure Storage FlashBlade REST 1.9 Python SDK, developed by [Pure Storage, Inc](http://www.purestorage.com/). Documentations can be found at [purity-fb.readthedocs.io](http://purity-fb.readthedocs.io/).

    OpenAPI spec version: 1.9
    Contact: info@purestorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ObjectStoreRemoteCredentials(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'created': 'int',
        'access_key_id': 'str',
        'secret_access_key': 'str',
        'remote': 'FixedReferenceWithId'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'created': 'created',
        'access_key_id': 'access_key_id',
        'secret_access_key': 'secret_access_key',
        'remote': 'remote'
    }

    def __init__(self, id=None, name=None, created=None, access_key_id=None, secret_access_key=None, remote=None):
        """
        ObjectStoreRemoteCredentials - a model defined in Swagger
        """

        self._id = None
        self._name = None
        self._created = None
        self._access_key_id = None
        self._secret_access_key = None
        self._remote = None

        if id is not None:
          self.id = id
        if name is not None:
          self.name = name
        if created is not None:
          self.created = created
        if access_key_id is not None:
          self.access_key_id = access_key_id
        if secret_access_key is not None:
          self.secret_access_key = secret_access_key
        if remote is not None:
          self.remote = remote

    @property
    def id(self):
        """
        Gets the id of this ObjectStoreRemoteCredentials.
        A non-modifiable, globally unique ID chosen by the system.

        :return: The id of this ObjectStoreRemoteCredentials.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ObjectStoreRemoteCredentials.
        A non-modifiable, globally unique ID chosen by the system.

        :param id: The id of this ObjectStoreRemoteCredentials.
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this ObjectStoreRemoteCredentials.
        name of the object (e.g., a file system or snapshot)

        :return: The name of this ObjectStoreRemoteCredentials.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ObjectStoreRemoteCredentials.
        name of the object (e.g., a file system or snapshot)

        :param name: The name of this ObjectStoreRemoteCredentials.
        :type: str
        """

        self._name = name

    @property
    def created(self):
        """
        Gets the created of this ObjectStoreRemoteCredentials.
        creation timestamp of the object

        :return: The created of this ObjectStoreRemoteCredentials.
        :rtype: int
        """
        return self._created

    @created.setter
    def created(self, created):
        """
        Sets the created of this ObjectStoreRemoteCredentials.
        creation timestamp of the object

        :param created: The created of this ObjectStoreRemoteCredentials.
        :type: int
        """

        self._created = created

    @property
    def access_key_id(self):
        """
        Gets the access_key_id of this ObjectStoreRemoteCredentials.
        Access Key ID to be used when connecting to a remote object store.

        :return: The access_key_id of this ObjectStoreRemoteCredentials.
        :rtype: str
        """
        return self._access_key_id

    @access_key_id.setter
    def access_key_id(self, access_key_id):
        """
        Sets the access_key_id of this ObjectStoreRemoteCredentials.
        Access Key ID to be used when connecting to a remote object store.

        :param access_key_id: The access_key_id of this ObjectStoreRemoteCredentials.
        :type: str
        """

        self._access_key_id = access_key_id

    @property
    def secret_access_key(self):
        """
        Gets the secret_access_key of this ObjectStoreRemoteCredentials.
        Secret Access Key to be used when connecting to a remote object store. After creation, listing will only show ****.

        :return: The secret_access_key of this ObjectStoreRemoteCredentials.
        :rtype: str
        """
        return self._secret_access_key

    @secret_access_key.setter
    def secret_access_key(self, secret_access_key):
        """
        Sets the secret_access_key of this ObjectStoreRemoteCredentials.
        Secret Access Key to be used when connecting to a remote object store. After creation, listing will only show ****.

        :param secret_access_key: The secret_access_key of this ObjectStoreRemoteCredentials.
        :type: str
        """

        self._secret_access_key = secret_access_key

    @property
    def remote(self):
        """
        Gets the remote of this ObjectStoreRemoteCredentials.
        Reference of the associated array connection or target.

        :return: The remote of this ObjectStoreRemoteCredentials.
        :rtype: FixedReferenceWithId
        """
        return self._remote

    @remote.setter
    def remote(self, remote):
        """
        Sets the remote of this ObjectStoreRemoteCredentials.
        Reference of the associated array connection or target.

        :param remote: The remote of this ObjectStoreRemoteCredentials.
        :type: FixedReferenceWithId
        """

        self._remote = remote

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ObjectStoreRemoteCredentials):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
